;=================================================================
;High-level syntax simulation for low-level conditional operations
__deflbl__	TEXTEQU	<__EXTENDED__CONDITIONAL__OPERATION__LABEL_>
__level__	TEXTEQU	<_>
__count__	TEXTEQU	<_>
__wloop__	TEXTEQU	<#>
__stack__	TEXTEQU	<#>
__list__	TEXTEQU	<#>

pushtxt	macro	name,stk
	stk		CATSTR	name,<#>,stk
endm
poptxt	macro	name,stk
	pos		INSTR	stk,<#>
	name	SUBSTR	stk,1,pos-1
	stk		SUBSTR	stk,pos+1
endm
get_new		macro	lvl,cnt,lst
	pos		INSTR	lst,<#>
	lvl		CATSTR	lvl,<L>
	cnt		CATSTR	<_>
	WHILE pos NE 0
		cnt		CATSTR	cnt,<C>
		cmpstr	CATSTR	lvl,<#>,cnt,<#>
		pos		INSTR	lst,cmpstr
	ENDM
	lst		CATSTR	lvl,<#>,cnt,<#>,lst
endm
get_next	macro	lvl,cnt,lst
	pos		INSTR	lst,<#>
	lvl		CATSTR	lvl
	cnt		CATSTR	<_>
	WHILE pos NE 0
		cnt		CATSTR	cnt,<C>
		cmpstr	CATSTR	lvl,<#>,cnt,<#>
		pos		INSTR	lst,cmpstr
	ENDM
	lst		CATSTR	lvl,<#>,cnt,<#>,lst
endm
jump_if_flag		MACRO	flag,dest
	IFIDNI	flag,<O>
		jo	dest
	ELSEIFIDNI	flag,<NO>
		jno	dest
	ELSEIFIDNI	flag,<B>
		jb	dest
	ELSEIFIDNI	flag,<NAE>
		jnae	dest
	ELSEIFIDNI	flag,<C>
		jc	dest
	ELSEIFIDNI	flag,<NC>
		jnc	dest
	ELSEIFIDNI	flag,<NB>
		jnb	dest
	ELSEIFIDNI	flag,<AE>
		jae	dest
	ELSEIFIDNI	flag,<CXZ>
		jcxz	dest
	ELSEIFIDNI	flag,<ECXZ>
		jecxz	dest
	ELSEIFIDNI	flag,<E>
		je	dest
	ELSEIFIDNI	flag,<Z>
		jz	dest
	ELSEIFIDNI	flag,<NE>
		jne	dest
	ELSEIFIDNI	flag,<NZ>
		jnz	dest
	ELSEIFIDNI	flag,<BE>
		jbe	dest
	ELSEIFIDNI	flag,<NA>
		jna	dest
	ELSEIFIDNI	flag,<NBE>
		jnbe	dest
	ELSEIFIDNI	flag,<A>
		ja	dest
	ELSEIFIDNI	flag,<S>
		js	dest
	ELSEIFIDNI	flag,<NS>
		jns	dest
	ELSEIFIDNI	flag,<P>
		jp	dest
	ELSEIFIDNI	flag,<PE>
		jpe	dest
	ELSEIFIDNI	flag,<NP>
		jnp	dest
	ELSEIFIDNI	flag,<PO>
		jpo	dest
	ELSEIFIDNI	flag,<L>
		jl	dest
	ELSEIFIDNI	flag,<NGE>
		jnge	dest
	ELSEIFIDNI	flag,<NL>
		jnl	dest
	ELSEIFIDNI	flag,<GE>
		jge	dest
	ELSEIFIDNI	flag,<LE>
		jle	dest
	ELSEIFIDNI	flag,<NG>
		jng	dest
	ELSEIFIDNI	flag,<NLE>
		jnle	dest
	ELSEIFIDNI	flag,<G>
		jg	dest
	ELSE
		ECHO Bad flag
		.ERR
	ENDIF
ENDM
jump_if_not_flag	MACRO	flag,dest
	IFIDNI	flag,<O>
		jno	dest
	ELSEIFIDNI	flag,<NO>
		jo	dest
	ELSEIFIDNI	flag,<B>
		jnb	dest
	ELSEIFIDNI	flag,<NAE>
		jae	dest
	ELSEIFIDNI	flag,<C>
		jnc	dest
	ELSEIFIDNI	flag,<NC>
		jc	dest
	ELSEIFIDNI	flag,<NB>
		jb	dest
	ELSEIFIDNI	flag,<AE>
		jnae	dest
	ELSEIFIDNI	flag,<CXZ>
		ECHO [WARNING] Unable to revert jcxz, adding a test
		test	cx,cx
		jnz		dest
	ELSEIFIDNI	flag,<ECXZ>
		ECHO [WARNING] Unable to revert jecxz, adding a test
		test	ecx,ecx
		jnz		dest
	ELSEIFIDNI	flag,<E>
		jne	dest
	ELSEIFIDNI	flag,<Z>
		jnz	dest
	ELSEIFIDNI	flag,<NE>
		je	dest
	ELSEIFIDNI	flag,<NZ>
		jz	dest
	ELSEIFIDNI	flag,<BE>
		jnbe	dest
	ELSEIFIDNI	flag,<NA>
		ja	dest
	ELSEIFIDNI	flag,<NBE>
		jbe	dest
	ELSEIFIDNI	flag,<A>
		jna	dest
	ELSEIFIDNI	flag,<S>
		jns	dest
	ELSEIFIDNI	flag,<NS>
		js	dest
	ELSEIFIDNI	flag,<P>
		jnp	dest
	ELSEIFIDNI	flag,<PE>
		jpo	dest
	ELSEIFIDNI	flag,<NP>
		jp	dest
	ELSEIFIDNI	flag,<PO>
		jpe	dest
	ELSEIFIDNI	flag,<L>
		jnl	dest
	ELSEIFIDNI	flag,<NGE>
		jge	dest
	ELSEIFIDNI	flag,<NL>
		jl	dest
	ELSEIFIDNI	flag,<GE>
		jnge	dest
	ELSEIFIDNI	flag,<LE>
		jnle	dest
	ELSEIFIDNI	flag,<NG>
		jg	dest
	ELSEIFIDNI	flag,<NLE>
		jle	dest
	ELSEIFIDNI	flag,<G>
		jng	dest
	ELSE
		ECHO Bad flag
		.ERR
	ENDIF
ENDM

;IF
fif		macro	flag:REQ
	pushtxt	__count__,__stack__
	pushtxt	__level__,__stack__
	
	get_next	<__level__>,<__count__>,<__list__>
	temp		CATSTR	__deflbl__,__level__,__count__
	
	jump_if_not_flag	<flag>,<temp>
endm
;ELSE
felse	macro
	temp		CATSTR	__deflbl__,__level__,__count__
	get_next	<__level__>,<__count__>,<__list__>
	temp_		CATSTR	__deflbl__,__level__,__count__
	
	jmp		temp_
	temp:
endm
;ELSE-IF
felseif	macro	flag:REQ
	fendif
	fif		<flag>
endm
;ENDIF
fendif	macro
	temp		CATSTR	__deflbl__,__level__,__count__
	temp:
	
	poptxt	__level__,__stack__
	poptxt	__count__,__stack__
endm

;REPEAT
frepeat	macro
	pushtxt	__count__,__stack__
	pushtxt	__level__,__stack__
	
	get_new		<__level__>,<__count__>,<__list__>
	temp		CATSTR	__deflbl__,__level__,__count__
	temp:
endm
;UNTIL
funtil	macro	flag:REQ
	temp				CATSTR	__deflbl__,__level__,__count__
	jump_if_not_flag	<flag>,<temp>
	
	get_next			<__level__>,<__count__>,<__list__>
	temp_				CATSTR	__deflbl__,__level__,__count__
	temp_:
	
	poptxt	__level__,__stack__
	poptxt	__count__,__stack__
endm

;WHILE
fwhile	macro	flag:req
	pushtxt	__count__,__stack__
	pushtxt	__level__,__stack__
	
	get_new		__level__,__count__,__list__
	temp		CATSTR	__deflbl__,__level__,__count__
	pushtxt		<flag>,__wloop__
	pushtxt		<temp>,__wloop__
	get_next	__level__,__count__,__list__
	temp_		CATSTR	__deflbl__,__level__,__count__
	
	jmp		temp_
	temp:
endm
;ENDW
fendw	macro
	temp_		CATSTR	__deflbl__,__level__,__count__
	get_next	__level__,__count__,__list__
	temp__		CATSTR	__deflbl__,__level__,__count__
	
	poptxt		<temp>,__wloop__
	poptxt		<flag>,__wloop__
	
	temp_:
	jump_if_flag	<flag>,<temp>
	temp__:
	
	poptxt	__level__,__stack__
	poptxt	__count__,__stack__
endm

;BREAK
fbreak	macro
	temp_	CATSTR	__deflbl__,__level__,__count__,<C>
	jmp		temp_
endm
;BREAK-IF
fbreakif	macro	flag:REQ
	temp			CATSTR	__deflbl__,__level__,__count__,<C>
	jump_if_flag	<flag>,<temp>
endm

fIf			EQU	<fif>
fElse		EQU	<felse>
fElseIf		EQU	<felseif>
fEndIf		EQU	<fendif>
fRepeat		EQU	<frepeat>
fUntil		EQU	<funtil>
fWhile		EQU	<fwhile>
fEndw		EQU	<fendw>
fBreak		EQU	<fbreak>
fBreakIf	EQU	<fbreakif>

FIF			EQU	<fif>
FELSE		EQU	<felse>
FELSEIF		EQU	<felseif>
FENDIF		EQU	<fendif>
FREPEAT		EQU	<frepeat>
FUNTIL		EQU	<funtil>
FWHILE		EQU	<fwhile>
FENDW		EQU	<fendw>
FBREAK		EQU	<fbreak>
FBREAKIF	EQU	<fbreakif>